<?
// maillist.php


    if (!isset($email) || !isset($name) || empty($email) || empty($name)) {
        fail("Both a name and an email address are required");
    }



$regexp = "^([a-zA-Z0-9._-]+)@([a-zA-Z0-9-])+(\.[a-zA-Z0-9-]+)+$";

if (eregi($regexp, $email)) {
    
} else {
     fail("Fake email address...");
}
    
    $email = strtolower($email);
    
   
    switch($action) {
        case "subscribe":
            subscribe($name, $email);
             break;
        
        case "unsubscribe":
            unsubscribe($email, $name);
            break;
    
        default:
            fail("Unknown action: $action");
    }
    
    
function subscribe($name, $email) {

    if (isSubscribed($email)) {
        fail("$email already subscribed to mailing list");
    }

    $joinDate = time();
    
    $file = fopen('eusers.dat', 'a+');
    
    if (!$file) {
        fail("Error: Couldn't open subscriber file");
    }
    
    fputs($file, "$name|$email|$joinDate\n");
    fclose($file);
    
    success();
}

       
function unsubscribe($email, $name) {
    if (!isSubscribed($email)) {
        fail("$email not subscribed to mailing list");
    }

    $subscribers = file('eusers.dat');
    
    if (!$subscribers) {
        fail("Error: Couldn't open subscriber file");
    }
    
    foreach($subscribers as $count => $subscriber) {
        $info = explode('|', $subscriber);
        
        if($info[1] == $email) {
            unset($subscribers[$count]);
        }
    }
    
    $file = fopen('eusers.dat', 'w');
    
    if (!$file) {
        fail("Couldn't remove subscriber from file");
    }
    
    foreach($subscribers as $subscriber) {
        fwrite($file, $subscriber);
    }        

    fclose($file);
        
    success();
}


function isSubscribed($email) {
    $matchFound = false;
    $subscribers = file('eusers.dat');
    
    if ($subscribers) {
        foreach($subscribers as $count => $subscriber) {
            $info = explode('|', $subscriber);
        
            if($info[1] == $email) {
                $matchFound = true;
            }
        }
    }
    
    return $matchFound;
}

function isBanned($email) {
    return false;
}

function fail($errorMsg) {
    $errorMsg = urlencode($errorMsg);
    print "&result=Fail&errorMsg=$errorMsg";
    exit;
}

function success() {
    print "&result=Okay";
    exit;
}

?>
